Subject: Re: next: /dev/root: Can't open blockdev

From: "Aithal, Srikanth" <[email-masked]>
Date: Wed, 7 Feb 2024 09:46:24 +0530

On 2/7/2024 4:35 AM, Marek Szyprowski wrote:
> Hi Christian,
> 
> On 06.02.2024 16:53, Christian Brauner wrote:
>>> On it.
>> Ok, can you try:
>> git://git.kernel.org/pub/scm/linux/kernel/git/vfs/vfs.git vfs.super.debug
>> please?
> 
> 
> I've also encountered this issue during my linux-next daily tests and I
> confirm that the above branch works fine.
> 
> 
> I've applied the diff between e3bfad989976^2 and the above branch
> (bc7cb6c829e2), which looks following:
> 
> diff --git a/init/do_mounts.c b/init/do_mounts.c
> index 279ad28bf4fb..d8ea839463a5 100644
> --- a/init/do_mounts.c
> +++ b/init/do_mounts.c
> @@ -19,6 +19,7 @@
>    #include <linux/ramfs.h>
>    #include <linux/shmem_fs.h>
>    #include <linux/ktime.h>
> +#include <linux/task_work.h>
> 
>    #include <linux/nfs_fs.h>
>    #include <linux/nfs_fs_sb.h>
> @@ -208,6 +209,10 @@ void __init mount_root_generic(char *name, char
> *pretty_name, int flags)
>                                   goto out;
>                           case -EACCES:
>                           case -EINVAL:
> +#ifdef CONFIG_BLOCK
> +                               flush_delayed_fput();
> +                               task_work_run();
> +#endif
>                                   continue;
>                   }
>                   /*
> 
> 
> onto next-20240206 and it fixed all boot problems I've observed on my
> test farm. :)
> 
> Tested-by: Marek Szyprowski <[email-masked]>
> 
> Best regards

We as well encountered this issue during our CI run. The given branch 
fixes the issues seen in our run.

Tested-by: Srikanth Aithal <[email-masked]>